;--------------------------------------------------------------------------
; X64 example that fills a 8000 bytes buffer and prints some msg on the
; screen. Author Greg L. on masm32 forum.
; -------------------------------------------------------------------------


EXTERN ExitProcess:PROC
EXTERN printf:PROC
EXTERN _getch:PROC

INCLUDELIB Kernel32.lib
INCLUDELIB msvcrt.lib

.DATA

    msg  BYTE "Clearing done",13,10,0
    msg1 BYTE "The test has taken: ",0 

.DATA?

    align 16

    buf2clear BYTE 8000 DUP(?)

.CODE

main PROC

;--------------------------------------------------------------------------
; point to insert the timings instructions - start
; -------------------------------------------------------------------------

    lea rcx, buf2clear
    call ClearBuffer
    
;--------------------------------------------------------------------------
; point to insert the timings instructions - end
; -------------------------------------------------------------------------

    lea rcx, msg
    call printf

    lea rcx, msg1
    call printf

;--------------------------------------------------------------------------
; point to insert the printf of the elapsed CPU cycles
; -------------------------------------------------------------------------
   
    call WaitKey

    xor ecx, ecx
    call ExitProcess

main ENDP

; -------------------------------------------------------------------------
; This PROC clear a buffer with 8.000 spaces
; -------------------------------------------------------------------------
ClearBuffer PROC

    push rdi
   
    mov rdi, rcx

    mov rcx, 1000   ; (SIZEOF buf2clear) / 8

    mov rax, 2020202020202020h

    rep stosq

    pop rdi

    ret

ClearBuffer ENDP

; -------------------------------------------------------------------------
; This PROC waits for a key to be pressed before ending the program
; -------------------------------------------------------------------------
WaitKey PROC

    ; int WaitKey(void);

    LOCAL dwChar:DWORD

    .DATA

        szPrompt BYTE 13,10,"Press any key to exit ... ", 0
        szCrLf   BYTE 13,10,0

    .CODE

        sub rsp, 40

        lea rcx, szPrompt
        call printf
        call _getch
        cmp eax, 0
        je again
        cmp eax, 0E0h
        je again
        jmp @F
     again:
        call _getch
     @@:
        mov dwChar, eax
        lea rcx, szCrLf
        call printf

        mov eax, dwChar
        add rsp, 40

        ret
WaitKey ENDP

;-----------------------------------------------------------
END